package cz.cvut.x33eja.servlet;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URL;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/*
 * GetImage servlet slouzi pro zobrazeni dat - at uz z url, file nebo databaze.
 */
public class GetImage extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setCharacterEncoding("UTF-8");
        response.setContentType("image/png");

        OutputStream out = response.getOutputStream();

        // Barva okraje se ziska z requestu
        String border = request.getParameter("imageBorder");

        // Nacteni textu pro zobrazeni ze session
        String text = (String) request.getSession().getAttribute("imageText");

        BufferedImage img = ImageIO.read(new URL("http://www.cvut.cz/fotobanka/fel/f3uvod.jpg"));
        Graphics2D g = img.createGraphics();

        if (border != null & border.length() > 0) {
            g.setStroke(new BasicStroke(10));
            g.setColor(new Color(Color.decode(border).getRGB()));
            g.drawRoundRect(0, 0, img.getWidth(), img.getHeight(), 10, 10);

            if (text != null) {
                g.setFont(new Font(Font.SERIF, Font.BOLD, 100));
                g.setColor(Color.BLACK);
                g.drawString(text, 250, 110);
            }
        }
        ImageIO.write(img, "png", out);
        g.dispose();
        img.flush();
        out.flush();
        out.close();
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
