package cz.cvut.x33eja.servlet;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
//import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet zpracuje data ziskana od klienta a vystup zobrazi jako stranku images.jsp
 */
// Misto deklarace servletu ve web.xml je mozne pouzit anotace
//@WebServlet(name="Images", urlPatterns={"/Images"})
public class Images extends HttpServlet {

    private static final Map<String, String> COLORS = new HashMap<String, String>() {

        {
            put("R", "#FF0000");
            put("G", "#00FF00");
            put("B", "#0000FF");
        }
    };

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String text = request.getParameter("imageText");
        request.getSession().setAttribute("imageText", text);

        String border = request.getParameter("imageBorder");
        request.setAttribute("imageBorder", COLORS.get(border));
//request.getServletPath()
        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/images.jsp");
        dispatcher.forward(request, response);

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Image text and border processing servlet";
    }// </editor-fold>
}
